import React from 'react';
export declare type CardHeaderHeightType = 'small' | 'normal' | 'large';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
/**
 * Empty header with just a bottom border
 */
export declare const BaseHeader: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {}, never>;
export declare const CardHeaderTypography: import("styled-components").StyledComponent<"p", import("styled-components").DefaultTheme, import("../Typography").TypographyProps & {
    variant: string;
}, "variant">;
export declare const CardSubHeaderTypography: import("styled-components").StyledComponent<"p", import("styled-components").DefaultTheme, import("../Typography").TypographyProps & {
    variant: string;
}, "variant">;
export interface CardHeaderProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: string;
}
export declare const CardHeader: React.FC<CardHeaderProps>;
export interface CardExpandableHeaderProps extends CardHeaderProps {
    readonly disabled?: boolean;
    readonly expanded?: boolean;
    readonly onToggle: (expanded: boolean) => void;
}
export declare const CardExpandableHeader: React.FC<CardExpandableHeaderProps>;
export {};
