import React from 'react';
interface DatePickerProps {
    /**
     * Current date value
     */
    readonly date: Date;
    /**
     * Fires when date is changed
     */
    readonly onChange: React.Dispatch<React.SetStateAction<Date>>;
    /**
     * Translation as locale string, used with javascript
     * Date object toLocaleString function.
     * Default `en`
     */
    readonly lang?: string;
}
/**
 * DatePicker
 *
 * Modal component that allows users to choose
 * date, time and time zone setting
 */
export declare const DatePicker: React.FC<DatePickerProps>;
export {};
