import React from 'react';
import { TranslationMeridiem } from './types';
interface TimePickerProps {
    /**
     * Current date value as date object
     */
    readonly date: Date;
    /**
     * Fires when date value is changed
     */
    readonly onChange: React.Dispatch<React.SetStateAction<Date>>;
}
/**
 * TimePickerTwentyFour
 *
 * Shows a clock component with 24 hour time options
 */
export declare const TimePickerTwentyFour: React.FC<TimePickerProps>;
interface TimePickerAMPMProps extends TimePickerProps {
    /**
     * AM/PM translation labels
     */
    readonly hour12MeridiemLabels: TranslationMeridiem;
}
/**
 * TimePickerAMPM
 *
 * Shows a clock component with AM/PM format.
 */
export declare const TimePickerAMPM: React.FunctionComponent<TimePickerAMPMProps>;
/**
 * MinutePicker
 *
 * Shows a clock component with minute values
 */
export declare const MinutePicker: React.FC<TimePickerProps>;
export {};
