"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FilePicker = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Typography = require("../Typography");

var _designparams = require("../designparams");

var _Button = require("../Button");

var _excluded = ["onFileChange", "disabled", "name", "variant", "label", "icon", "className", "onChange"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ButtonFileChooserContainer = _styledComponents.default.div.withConfig({
  displayName: "FilePicker__ButtonFileChooserContainer",
  componentId: "sc-121j7bw-0"
})(["display:flex;justify-content:left;align-items:center;> button{margin-right:", ";}"], _designparams.spacing.medium);

var FileInput = _styledComponents.default.input.withConfig({
  displayName: "FilePicker__FileInput",
  componentId: "sc-121j7bw-1"
})(["display:none;"]);

/**
 * FilePicker
 *
 * Can be used when file input from user is needed.
 *
 * The component is built with a Button component. When the user
 * clicks the button a input file chooser dialog will appear.
 *
 */
var FilePicker = _ref => {
  var {
    onFileChange,
    disabled,
    name,
    variant,
    label,
    icon,
    className,
    onChange
  } = _ref,
      props = _objectWithoutProperties(_ref, _excluded);

  var ref = (0, _react.useRef)(null);
  var [fileName, setFileName] = (0, _react.useState)('');
  var onButtonClick = (0, _react.useCallback)(() => {
    if (ref.current !== null) {
      ref.current.click();
    }
  }, [ref]);
  var handleFileChange = (0, _react.useCallback)(e => {
    var _e$target$files;

    onChange === null || onChange === void 0 ? void 0 : onChange(e);
    var chosenFile = (_e$target$files = e.target.files) === null || _e$target$files === void 0 ? void 0 : _e$target$files[0];

    if (chosenFile === undefined) {
      return;
    }

    setFileName(chosenFile.name);
    onFileChange === null || onFileChange === void 0 ? void 0 : onFileChange(chosenFile);
  }, [onFileChange, onChange]);
  return /*#__PURE__*/_react.default.createElement(ButtonFileChooserContainer, {
    className: className
  }, /*#__PURE__*/_react.default.createElement(_Button.Button, {
    disabled: disabled,
    name: name,
    onClick: onButtonClick,
    variant: variant,
    className: className,
    label: label,
    type: "button",
    icon: icon
  }), /*#__PURE__*/_react.default.createElement(FileInput, _extends({
    type: "file",
    ref: ref,
    onChange: handleFileChange
  }, props)), /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "default-text"
  }, fileName));
};

exports.FilePicker = FilePicker;