"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseMenu = exports.MenuList = exports.MenuButton = exports.BaseMenuItem = exports.MenuButtonHalo = exports.MenuButtonIcon = exports.MenuButtonIconContainer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _designparams = require("../designparams");

var _math = require("../utils/math");

var _Icon = require("../Icon");

var _PopOver = require("../PopOver");

var _useEscapeListenerStack = require("../Modal/hooks/useEscapeListenerStack");

var _excluded = ["disabled", "name", "onClick", "className", "onPointerDown", "onPointerUp", "onFocus", "children"],
    _excluded2 = ["onEscape", "children", "onPointerDown"],
    _excluded3 = ["button", "align", "disabled", "components", "onBlur"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var MENU_MIN_WIDTH = '232px';
var MENU_MAX_HEIGHT = '360px';

var Anchor = _styledComponents.default.div.withConfig({
  displayName: "BaseMenu__Anchor",
  componentId: "sc-18n6efz-0"
})(["width:fit-content;height:fit-content;"]);

var MenuButtonIconContainer = _styledComponents.default.div.withConfig({
  displayName: "BaseMenu__MenuButtonIconContainer",
  componentId: "sc-18n6efz-1"
})(["position:relative;box-sizing:border-box;height:", ";width:", ";border-radius:", ";display:flex;align-items:center;justify-content:center;"], _designparams.componentSize.small, _designparams.componentSize.small, _designparams.shape.radius.circle);

exports.MenuButtonIconContainer = MenuButtonIconContainer;
var MenuButtonIcon = (0, _styledComponents.default)(_Icon.Icon).attrs({
  className: 'sc-ButtonIcon'
}).withConfig({
  displayName: "BaseMenu__MenuButtonIcon",
  componentId: "sc-18n6efz-2"
})(["fill:inherit;flex:none;"]);
exports.MenuButtonIcon = MenuButtonIcon;

var MenuButtonHalo = _styledComponents.default.div.withConfig({
  displayName: "BaseMenu__MenuButtonHalo",
  componentId: "sc-18n6efz-3"
})(["position:absolute;top:0;right:0;bottom:0;left:0;border-radius:", ";background-color:transparent;outline:none;transform:scale(0.3);transition:transform 100ms;"], _designparams.shape.radius.circle);

exports.MenuButtonHalo = MenuButtonHalo;

var MenuNativeButton = _styledComponents.default.button.withConfig({
  displayName: "BaseMenu__MenuNativeButton",
  componentId: "sc-18n6efz-4"
})(["flex:none;min-width:unset;padding:unset;outline:none;cursor:pointer;border:0;&::-moz-focus-inner{border:0;}color:", ";fill:", ";background-color:transparent;transition:all 200ms;", "{border:2px solid transparent;}&:hover{", "{border:0 solid transparent;}", "{background-color:", ";transform:scale(1);}}&:focus{", "}&:active{", "{background-color:", ";transform:scale(1.06);}}", ""], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text04();
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text04();
}, MenuButtonIconContainer, MenuButtonIconContainer, MenuButtonHalo, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.element11(_designparams.opacity[16]);
}, _ref4 => {
  var {
    visibleFocus
  } = _ref4;
  return visibleFocus ? (0, _styledComponents.css)(["&:focus{", "{border:2px solid ", ";}", "{background-color:", ";transform:scale(1);}}"], MenuButtonIconContainer, _ref5 => {
    var {
      theme
    } = _ref5;
    return theme.color.elementBorder();
  }, MenuButtonHalo, _ref6 => {
    var {
      theme
    } = _ref6;
    return theme.color.element11(_designparams.opacity[16]);
  }) : undefined;
}, MenuButtonHalo, _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.color.element11(_designparams.opacity[24]);
}, _ref8 => {
  var {
    disabled
  } = _ref8;
  return disabled === true ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;cursor:default;box-shadow:none;"], _designparams.opacity[48]) : undefined;
});

var MenuContainer = _styledComponents.default.div.withConfig({
  displayName: "BaseMenu__MenuContainer",
  componentId: "sc-18n6efz-5"
})(["color:", ";background-color:", ";box-shadow:", ";min-width:", ";max-height:", ";padding:", " 0;border-radius:", ";overflow:auto;"], _ref9 => {
  var {
    theme
  } = _ref9;
  return theme.color.text06();
}, _ref10 => {
  var {
    theme
  } = _ref10;
  return theme.color.background05();
}, _ref11 => {
  var {
    theme
  } = _ref11;
  return theme.shadow.menu;
}, MENU_MIN_WIDTH, MENU_MAX_HEIGHT, _designparams.spacing.medium, _designparams.shape.radius.medium);

var BaseMenuItem = _styledComponents.default.div.withConfig({
  displayName: "BaseMenu__BaseMenuItem",
  componentId: "sc-18n6efz-6"
})(["box-sizing:border-box;cursor:pointer;user-select:none;fill:red;&:hover{background-color:", ";}", " ", ""], _ref12 => {
  var {
    theme
  } = _ref12;
  return theme.color.background02();
}, _ref13 => {
  var {
    keyboardSelect
  } = _ref13;
  return keyboardSelect === true ? (0, _styledComponents.css)(["background-color:", ";"], _ref14 => {
    var {
      theme
    } = _ref14;
    return theme.color.background02();
  }) : undefined;
}, _ref15 => {
  var {
    disabled
  } = _ref15;
  return disabled === true ? (0, _styledComponents.css)(["opacity:", ";cursor:default;"], _designparams.opacity[48]) : undefined;
});

exports.BaseMenuItem = BaseMenuItem;

var MenuButton = /*#__PURE__*/_react.default.forwardRef((_ref16, ref) => {
  var {
    disabled,
    name,
    onClick,
    className,
    onPointerDown,
    onPointerUp,
    onFocus,
    children
  } = _ref16,
      props = _objectWithoutProperties(_ref16, _excluded);

  var {
    isPointerOn,
    isPointerOff,
    determineVisibleFocus,
    visibleFocus
  } = (0, _reactHooksShareable.useVisibleFocus)();
  var handleFocus = (0, _react.useCallback)(e => {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus(e);
    determineVisibleFocus();
  }, [determineVisibleFocus, onFocus]);
  var handlePointerDown = (0, _react.useCallback)(e => {
    onPointerDown === null || onPointerDown === void 0 ? void 0 : onPointerDown(e);
    isPointerOn();
  }, [isPointerOn, onPointerDown]);
  var handlePointerUp = (0, _react.useCallback)(e => {
    onPointerUp === null || onPointerUp === void 0 ? void 0 : onPointerUp(e);
    isPointerOff();
  }, [isPointerOff, onPointerUp]);
  return /*#__PURE__*/_react.default.createElement(MenuNativeButton, _extends({
    ref: ref,
    disabled: disabled,
    name: name,
    type: "button",
    onClick: onClick,
    className: className,
    onPointerDown: handlePointerDown,
    onPointerUp: handlePointerUp,
    onFocus: handleFocus,
    visibleFocus: visibleFocus
  }, props), children);
});

exports.MenuButton = MenuButton;
MenuButton.displayName = 'MenuButton';
/**
 * For keyboard interaction
 */

var MenuKeys;
/**
 * Add an escape listener to the actual rendered menu.
 */

(function (MenuKeys) {
  MenuKeys["Space"] = " ";
  MenuKeys["Enter"] = "Enter";
  MenuKeys["Escape"] = "Escape";
  MenuKeys["Esc"] = "Esc";
  MenuKeys["Home"] = "Home";
  MenuKeys["End"] = "End";
  MenuKeys["ArrowRight"] = "ArrowRight";
  MenuKeys["ArrowUp"] = "ArrowUp";
  MenuKeys["ArrowLeft"] = "ArrowLeft";
  MenuKeys["ArrowDown"] = "ArrowDown";
})(MenuKeys || (MenuKeys = {}));

var MenuList = _ref17 => {
  var {
    onEscape,
    children,
    onPointerDown
  } = _ref17,
      props = _objectWithoutProperties(_ref17, _excluded2);

  // Close when pressing escape key.
  (0, _useEscapeListenerStack.useEscapeListenerStack)(onEscape);
  return /*#__PURE__*/_react.default.createElement(MenuContainer, props, children);
};

exports.MenuList = MenuList;

var BaseItem = _ref18 => {
  var {
    component,
    onClick,
    disabled,
    keyboardSelect
  } = _ref18;
  var clickHandler = (0, _react.useCallback)(event => {
    if (disabled === true) {
      // Prevent event from bubbling up to the wrapper
      // that closes the menu
      event.stopPropagation();
      return;
    }

    onClick(event);
  }, [disabled, onClick]);
  var preventMenuBlur = (0, _react.useCallback)(e => {
    // Prevent the menu from losing focus when clicking down on an item.
    e.preventDefault();
  }, []);
  return /*#__PURE__*/_react.default.createElement(BaseMenuItem, {
    onPointerDown: preventMenuBlur,
    onClick: clickHandler,
    disabled: disabled,
    keyboardSelect: keyboardSelect
  }, component);
};

/**
 * BaseMenu
 *
 * Anchor with a button that toggles a menu when you click the button.
 * When pressing the escape key, the menu is closed.
 */
var BaseMenu = /*#__PURE__*/(0, _react.memo)(_ref19 => {
  var {
    button,
    align = 'left',
    disabled = false,
    components,
    onBlur
  } = _ref19,
      props = _objectWithoutProperties(_ref19, _excluded3);

  var [menuVisible, openMenu, hideMenu] = (0, _reactHooksShareable.useBoolean)(false);
  var anchorRef = (0, _react.useRef)(null);
  var [arrowIndex, setArrowIndex] = (0, _react.useState)(-1);
  var hideAndBlurMenu = (0, _react.useCallback)(() => {
    if (document.activeElement instanceof HTMLElement) {
      document.activeElement.blur();
    }

    hideMenu();
  }, [hideMenu]);
  var handleBlur = (0, _react.useCallback)(e => {
    onBlur === null || onBlur === void 0 ? void 0 : onBlur(e);
    hideMenu();
  }, [onBlur, hideMenu]);
  var mouseToggleMenu = (0, _react.useCallback)(event => {
    event.stopPropagation();

    if (menuVisible) {
      hideAndBlurMenu();
    } else {
      // Reset arrowIndex before Menu opens
      setArrowIndex(-1);
      openMenu();
    }
  }, [menuVisible, hideAndBlurMenu, openMenu]);
  var moveArrowMenuIndex = (0, _react.useCallback)(increment => {
    var nextIndex = (0, _math.remainder)(arrowIndex + increment, components.length);
    return setArrowIndex(nextIndex);
  }, [arrowIndex, components.length]);
  var handleKeyDown = (0, _react.useCallback)(event => {
    if (!(event.key in MenuKeys)) {
      return;
    }

    event.preventDefault();

    switch (event.key) {
      case MenuKeys.Enter:
      case MenuKeys.Space:
        {
          if (menuVisible) {
            if (components[arrowIndex].disabled !== true) {
              components[arrowIndex].onClick(event);
              hideMenu();
              break;
            }

            break;
          }

          openMenu();
          setArrowIndex(0);
          break;
        }

      case MenuKeys.Escape:
      case MenuKeys.Esc:
        {
          hideMenu();
          break;
        }

      case MenuKeys.ArrowUp:
        {
          if (menuVisible) {
            moveArrowMenuIndex(-1);
            break;
          }

          openMenu();
          setArrowIndex(0);
          break;
        }

      case MenuKeys.ArrowDown:
        {
          if (menuVisible) {
            moveArrowMenuIndex(1);
            break;
          }

          openMenu();
          setArrowIndex(0);
          break;
        }

      case MenuKeys.ArrowRight:
      case MenuKeys.ArrowLeft:
        {
          hideMenu();
          break;
        }

      case MenuKeys.Home:
        {
          if (menuVisible) {
            setArrowIndex(0);
            break;
          }

          break;
        }

      case MenuKeys.End:
        {
          if (menuVisible) {
            setArrowIndex(components.length - 1);
            break;
          }

          break;
        }

      default:
    }
  }, [menuVisible, openMenu, components, arrowIndex, hideMenu, moveArrowMenuIndex]);
  return /*#__PURE__*/_react.default.createElement(Anchor, _extends({
    ref: anchorRef,
    onKeyDown: handleKeyDown,
    onBlur: handleBlur
  }, props), /*#__PURE__*/_react.default.createElement(MenuButton, {
    onClick: mouseToggleMenu,
    disabled: disabled
  }, button), menuVisible ? /*#__PURE__*/_react.default.createElement(_PopOver.PopOver, {
    horizontalPosition: align,
    horizontalAlignment: align,
    anchorEl: anchorRef.current,
    onScroll: hideAndBlurMenu
  }, /*#__PURE__*/_react.default.createElement(MenuList, {
    onEscape: hideMenu,
    onClick: hideAndBlurMenu
  }, components.map((component, index) => /*#__PURE__*/_react.default.createElement(BaseItem, _extends({
    key: index,
    keyboardSelect: index === arrowIndex
  }, component))))) : null);
});
exports.BaseMenu = BaseMenu;
BaseMenu.displayName = 'BaseMenu';