import React from 'react';
import { Theme } from './theme';
import { ToastsPlacement } from './Toast/ToastsProvider';
import { SimpleToastsDurations } from './Toast';
interface ToastsOptions {
    /**
     * Position of toasts on the page.
     */
    readonly placement: ToastsPlacement;
    /**
     * Determine if toasts should be always on top (above any other modal layers),
     * or not (above the main application layer but below any other modal layers).
     *
     * @default true
     */
    readonly alwaysOnTop: boolean;
    /**
     * Default toast durations
     */
    readonly defaultDurations: SimpleToastsDurations;
}
interface PracticalProviderProps extends SimpleToastsDurations {
    /**
     * The Practical React Components theme to be used.
     */
    readonly theme?: Theme;
    /**
     * The toasts layout.
     *
     * @default Toasts are centered at the top and always visible.
     */
    readonly toastsOptions?: ToastsOptions;
}
export declare const PracticalProvider: React.FC<PracticalProviderProps>;
interface LayerContextType {
    readonly el: HTMLElement | null;
    readonly id: string;
}
export declare const LayerContext: React.Context<LayerContextType>;
interface LayerProps {
    readonly zIndex?: number;
}
export declare const Layer: React.FC<LayerProps>;
export {};
