import { BaseToastValue, ToastAction, ToastId } from './context';
export declare type ToastsMap = ReadonlyMap<ToastId, BaseToastValue>;
/**
 * Given the current state (toast map) and an action,
 * produce a new state depending on the action.
 * The new map of toasts (id => toast) is immutable.
 *
 * @param state The map of id -> toast connections
 * @param action The required action
 */
export declare const toastReducer: (state: ToastsMap, action: ToastAction) => ToastsMap | Map<any, any>;
