import React from 'react';
import { TypographyProps } from '../Typography';
import { PopOverProps } from '../PopOver';
export declare const ExpandedTooltipTypography: React.FC<Omit<TypographyProps, 'variant'>>;
interface TooltipProps extends Omit<PopOverProps, 'anchorEl'> {
    /**
     * Optional Tooltip variant.
     * Default: `default`
     */
    readonly variant?: 'default';
    /**
     * text inside the tooltip.
     */
    readonly text: string;
}
interface ExpandedTooltipProps extends Omit<PopOverProps, 'anchorEl'> {
    /**
     * Required Tooltip variant.
     */
    readonly variant: 'expanded';
    /**
     * Optional semibold title text inside the tooltip.
     */
    readonly tipTitle?: string;
    /**
     * Optional extra info shown in the right corner.
     */
    readonly extraInfo?: string;
    /**
     * React element that will appear under the tipTitle.
     * Recommend to use `ExpandedTooltipTypography` to get proper Typography.
     */
    readonly contents: React.ReactNode;
}
export declare const Tooltip: React.FC<TooltipProps | ExpandedTooltipProps>;
export {};
